Class UmlBaseClass

Manage the classes

Declaration :

- C++ : class UmlBaseClass : public UmlClassMember
- Java : abstract class UmlBaseClass extends UmlClassMember

Directly inherited by : UmlClass

Artifact : UmlBaseClass

Operation create

returns a new class named 's' created under 'parent'
In case it cannot be created (the name is already used or
invalid, 'parent' cannot contain it etc ...) return 0 in C++
and produce a RuntimeException in Java

Declaration :

- Uml : static, + create(inout parent : UmlItem, in s : str) : UmlClass, exceptions : RuntimeException
- C++ : public: static UmlClass * create(UmlItem * parent, const char * s)
- Java : public static UmlClass create(UmlItem parent, String s) throws RuntimeException

Operation kind

returns the kind of the item

Declaration :

- Uml : + kind() : anItemKind
- C++ : public: virtual anItemKind kind()
- Java : public anItemKind kind()

Operation isAbstract

returns TRUE in case the class is abstract

Declaration :

- Uml : + isAbstract() : bool
- C++ : public: bool isAbstract()
- Java : public boolean isAbstract()

Operation set_isAbstract

the set if the class is abstract
On error return FALSE in C++, produce a RuntimeException in Java,
for instance you cannot set it to FALSE in case the class have
abstract operations

Declaration :

- Uml : + set_isAbstract(in y : bool) : bool, exceptions : RuntimeException
- C++ : public: bool set_isAbstract(bool y)
- Java : public void set_isAbstract(boolean y) throws RuntimeException

Operation baseType

returns the type on which the class (in fact a typedef) is based

Declaration :

- Uml : + baseType() : UmlTypeSpec
- C++ : public: const UmlTypeSpec & baseType()
- Java : public UmlTypeSpec baseType()

Operation set_BaseType

to set the type on which the class (in fact a typedef) is based
On error return FALSE in C++, produce a RuntimeException in Java, does not check that the class is (already) a typedef

Declaration :

- Uml : + set_BaseType(in t : UmlTypeSpec) : bool, exceptions : RuntimeException
- C++ : public: bool set_BaseType(const UmlTypeSpec & t)
- Java : public void set_BaseType(UmlTypeSpec t) throws RuntimeException

Operation formals

returns (a copy of) the formals list

Declaration :

- Uml : + formals() : UmlFormalParameter
- C++ : public: QValueList<UmlFormalParameter> formals()
- Java : public UmlFormalParameter[] formals()

Operation removeFormal

remove the formal of the given rank (0...), returns 0 on error
On error return FALSE in C++, produce a RuntimeException in Java,
does not check that the class is (already) a typedef

Declaration :

- Uml : + removeFormal(in rank : uint) : bool, exceptions : RuntimeException
- C++ : public: bool removeFormal(unsigned int rank)
- Java : public void removeFormal(int rank) throws RuntimeException

Operation addFormal

adds a formal at the given rank (0...), returns 0 on error
On error return FALSE in C++, produce a RuntimeException in Java,
does not check that the class is (already) a typedef

Declaration :

- Uml : + addFormal(in rank : uint, in formal : UmlFormalParameter) : bool, exceptions : RuntimeException
- C++ : public: bool addFormal(unsigned int rank, const UmlFormalParameter & formal)
- Java : public void addFormal(int rank, UmlFormalParameter formal) throws RuntimeException

Operation replaceFormal

replace the formal at the given rank (0...)
On error return FALSE in C++, produce a RuntimeException in Java,
does not check that the class is (already) a typedef

Declaration :

- Uml : + replaceFormal(in rank : uint, in formal : UmlFormalParameter) : bool, exceptions : RuntimeException
- C++ : public: bool replaceFormal(unsigned int rank, const UmlFormalParameter & formal)
- Java : public void replaceFormal(int rank, UmlFormalParameter formal) throws RuntimeException

Operation actuals

returns (a copy of) the actuals list

Declaration :

- Uml : + actuals() : UmlActualParameter
- C++ : public: QValueList<UmlActualParameter> actuals()
- Java : public UmlActualParameter[] actuals()

Operation replaceActual

replace the actual value at the given rank (0...)
On error return FALSE in C++, produce a RuntimeException in Java

Declaration :

- Uml : + replaceActual(in rank : uint, in type : UmlTypeSpec) : bool, exceptions : RuntimeException
- C++ : public: bool replaceActual(unsigned int rank, const UmlTypeSpec & type)
- Java : public void replaceActual(int rank, UmlTypeSpec type) throws RuntimeException

Operation associatedDiagram

returns the optional associated diagram

Declaration :

- Uml : + associatedDiagram() : UmlClassDiagram
- C++ : public: UmlClassDiagram * associatedDiagram()
- Java : public UmlClassDiagram associatedDiagram()

Operation set_AssociatedDiagram

sets the associated diagram, arg may be null to unset it
On error return FALSE in C++, produce a RuntimeException in Java

Declaration :

- Uml : + set_AssociatedDiagram(inout d : UmlClassDiagram) : bool, exceptions : RuntimeException
- C++ : public: bool set_AssociatedDiagram(UmlClassDiagram * d)
- Java : public void set_AssociatedDiagram(UmlClassDiagram d) throws RuntimeException

Operation associatedArtifact

returns the optional associated artifact,
to set it refer to the UmlBaseArtifact's operations
addAssociatedClass(), removeAssociatedClass() and
setAssociatedClasses()

Declaration :

- Uml : + associatedArtifact() : UmlArtifact
- C++ : public: UmlArtifact * associatedArtifact()
- Java : public UmlArtifact associatedArtifact()

Operation associatedComponents

returns the components realizing or providing the class.
To set them refer to the UmlBaseComponent's operation setAssociatedClasses()

Declaration :

- Uml : + associatedComponents() : UmlComponent
- C++ : public: const QVector<UmlComponent> associatedComponents()
- Java : public UmlComponent[] associatedComponents()

Operation isCppExternal

returns TRUE if the class is external, its definition
must contains how the name is made on the first line
(isCppExternal by default), the other lines if they exist
must contains the #include and may be using forms

Declaration :

- Uml : + isCppExternal() : bool
- C++ : public: bool isCppExternal()
- Java : public boolean isCppExternal()

Operation set_isCppExternal

set if the class is external
On error return FALSE in C++, produce a RuntimeException in Java

Declaration :

- Uml : + set_isCppExternal(in y : bool) : bool, exceptions : RuntimeException
- C++ : public: bool set_isCppExternal(bool y)
- Java : public void set_isCppExternal(boolean y) throws RuntimeException

Operation isJavaExternal

returns TRUE if the class is external, its definition
must contain how the name is made on the first line
(isJavaExternal by default), the other lines are ignored

Declaration :

- Uml : + isJavaExternal() : bool
- C++ : public: bool isJavaExternal()
- Java : public boolean isJavaExternal()

Operation set_isJavaExternal

set if the class is external
On error return FALSE in C++, produce a RuntimeException in Java

Declaration :

- Uml : + set_isJavaExternal(in y : bool) : bool, exceptions : RuntimeException
- C++ : public: bool set_isJavaExternal(bool y)
- Java : public void set_isJavaExternal(boolean y) throws RuntimeException

Operation isJavaPublic

returns TRUE is the class is public

Declaration :

- Uml : + isJavaPublic() : bool
- C++ : public: bool isJavaPublic()
- Java : public boolean isJavaPublic()

Operation set_isJavaPublic

set if the class is public
On error return FALSE in C++, produce a RuntimeException in Java

Declaration :

- Uml : + set_isJavaPublic(in y : bool) : bool, exceptions : RuntimeException
- C++ : public: bool set_isJavaPublic(bool y)
- Java : public void set_isJavaPublic(boolean y) throws RuntimeException

Operation isJavaFinal

returns TRUE is the class is final

Declaration :

- Uml : + isJavaFinal() : bool
- C++ : public: bool isJavaFinal()
- Java : public boolean isJavaFinal()

Operation set_isJavaFinal

set if the class is final
On error return FALSE in C++, produce a RuntimeException in Java

Declaration :

- Uml : + set_isJavaFinal(in y : bool) : bool, exceptions : RuntimeException
- C++ : public: bool set_isJavaFinal(bool y)
- Java : public void set_isJavaFinal(boolean y) throws RuntimeException

Operation isPhpExternal

returns TRUE if the class is external, its definition
must contain how the name is made on the first line
(isPhpExternal by default), the other lines are ignored

Declaration :

- Uml : + isPhpExternal() : bool
- C++ : public: bool isPhpExternal()
- Java : public boolean isPhpExternal()

Operation set_isPhpExternal

set if the class is external
On error return FALSE in C++, produce a RuntimeException in Java

Declaration :

- Uml : + set_isPhpExternal(in y : bool) : bool, exceptions : RuntimeException
- C++ : public: bool set_isPhpExternal(bool y)
- Java : public void set_isPhpExternal(boolean y) throws RuntimeException

Operation isPhpFinal

returns TRUE is the class is final

Declaration :

- Uml : + isPhpFinal() : bool
- C++ : public: bool isPhpFinal()
- Java : public boolean isPhpFinal()

Operation set_isPhpFinal

set if the class is final
On error return FALSE in C++, produce a RuntimeException in Java

Declaration :

- Uml : + set_isPhpFinal(in y : bool) : bool, exceptions : RuntimeException
- C++ : public: bool set_isPhpFinal(bool y)
- Java : public void set_isPhpFinal(boolean y) throws RuntimeException

Operation switchType

returns the switch's type, significant in case the class
is an union in IDL

Declaration :

- Uml : + switchType() : UmlTypeSpec
- C++ : public: const UmlTypeSpec & switchType()
- Java : public UmlTypeSpec switchType()

Operation set_SwitchType

to set the switch type even the class is not (already) an IDL union
On error return FALSE in C++, produce a RuntimeException in Java

Declaration :

- Uml : + set_SwitchType(in t : UmlTypeSpec) : bool, exceptions : RuntimeException
- C++ : public: bool set_SwitchType(const UmlTypeSpec & t)
- Java : public void set_SwitchType(UmlTypeSpec t) throws RuntimeException

Operation isIdlExternal

returns TRUE if the class is external, its definition
must contain how the name is made on the first line
(isIdlExternal by default), the other lines are ignored

Declaration :

- Uml : + isIdlExternal() : bool
- C++ : public: bool isIdlExternal()
- Java : public boolean isIdlExternal()

Operation set_isIdlExternal

set if the class is external
On error return FALSE in C++, produce a RuntimeException in Java

Declaration :

- Uml : + set_isIdlExternal(in y : bool) : bool, exceptions : RuntimeException
- C++ : public: bool set_isIdlExternal(bool y)
- Java : public void set_isIdlExternal(boolean y) throws RuntimeException

Operation isIdlLocal

returns TRUE if the class is local, have sense for an interface

Declaration :

- Uml : + isIdlLocal() : bool
- C++ : public: bool isIdlLocal()
- Java : public boolean isIdlLocal()

Operation set_isIdlLocal

set if the class is local, have sense for an interface
On error return FALSE in C++, produce a RuntimeException in Java

Declaration :

- Uml : + set_isIdlLocal(in y : bool) : bool, exceptions : RuntimeException
- C++ : public: bool set_isIdlLocal(bool y)
- Java : public void set_isIdlLocal(boolean y) throws RuntimeException

Operation isIdlCustom

returns TRUE is the class is custom, have sense for a valuetype

Declaration :

- Uml : + isIdlCustom() : bool
- C++ : public: bool isIdlCustom()
- Java : public boolean isIdlCustom()

Operation set_isIdlCustom

set if the class is custom have sense for aa valuetype
On error return FALSE in C++, produce a RuntimeException in Java

Declaration :

- Uml : + set_isIdlCustom(in y : bool) : bool
- C++ : public: bool set_isIdlCustom(bool y)
- Java : public void set_isIdlCustom(boolean y)

Operation get

returns the class having the name given in argument in case it
exist, else 0/null. In case the package is specified (not 0/null),
the returned class will be defined in a sub-level of the package.

Declaration :

- Uml : static, + get(in n : string, in p : UmlPackage) : UmlClass
- C++ : public: static UmlClass * get(const QCString & n, const UmlPackage * p)
- Java : public static UmlClass get(String n, UmlPackage p)

Operation unload

to unload the object to free memory, it will be reloaded automatically
if needed. Recursively done for the sub items if 'rec' is TRUE.
if 'del' is true the sub items are deleted in C++, and removed from the
internal dictionnary in C++ and Java (to allow it to be garbaged),
you will have to call Children() to re-access to them

Declaration :

- Uml : + unload(in rec : bool, in del : bool) : void
- C++ : public: virtual void unload(bool rec = FALSE, bool del = FALSE)
- Java : public void unload(boolean rec, boolean del)

Operation set_Name

to set the name
On error return FALSE in C++, produce a RuntimeException in Java

Declaration :

- Uml : + set_Name(in s : string) : bool, exceptions : RuntimeException
- C++ : public: virtual bool set_Name(const QCString & s)
- Java : public void set_Name(String s) throws RuntimeException

Attribut _classes

Declaration :

- Uml : static, - _classes : UmlClass
- C++ : private: static QDict<UmlClass> _classes
- Java : private static Hashtable _classes

Extra Class Member initialization

Definition :

- Java :

        static { _classes = new Hashtable(1001); }

Attribut _abstract

Declaration :

- Uml : - _abstract : bool
- C++ : private: bool _abstract
- Java : private boolean _abstract

Attribut _cpp_external

Declaration :

- Uml : - _cpp_external : bool
- C++ : private: bool _cpp_external : 1
- Java : private boolean _cpp_external

Attribut _java_external

Declaration :

- Uml : - _java_external : bool
- C++ : private: bool _java_external : 1
- Java : private boolean _java_external

Attribut _java_final

Declaration :

- Uml : - _java_final : bool
- C++ : private: bool _java_final
- Java : private boolean _java_final

Attribut _php_external

Declaration :

- Uml : - _php_external : bool
- C++ : private: bool _php_external : 1
- Java : private boolean _php_external

Attribut _php_final

Declaration :

- Uml : - _php_final : bool
- C++ : private: bool _php_final
- Java : private boolean _php_final

Attribut _idl_external

Declaration :

- Uml : - _idl_external : bool
- C++ : private: bool _idl_external
- Java : private boolean _idl_external

Attribut _idl_local

Declaration :

- Uml : - _idl_local : bool
- C++ : private: bool _idl_local
- Java : private boolean _idl_local

Attribut _idl_custom

Declaration :

- Uml : - _idl_custom : bool
- C++ : private: bool _idl_custom
- Java : private boolean _idl_custom

Relation _base_type (<directional composition>)

Declaration :

- Uml : - _base_type : UmlTypeSpec
- C++ : private: UmlTypeSpec _base_type
- Java : private UmlTypeSpec _base_type

Relation _assoc_diagram (<unidirectional association>)

Declaration :

- Uml : - _assoc_diagram : UmlClassDiagram
- C++ : private: UmlClassDiagram * _assoc_diagram
- Java : private UmlClassDiagram _assoc_diagram

Relation _switch_type (<directional composition>)

union

Declaration :

- Uml : - _switch_type : UmlTypeSpec
- C++ : private: UmlTypeSpec _switch_type
- Java : private UmlTypeSpec _switch_type

Operation UmlBaseClass

the constructor, do not call it yourself !!!!!!!!!!

Declaration :

- Uml : # UmlBaseClass(in id : item_id, in n : string) :
- C++ : protected: UmlBaseClass(void * id, const QCString & n)
- Java : protected UmlBaseClass(long id, String n)

Operation read_uml_

internal, do NOT use it

Declaration :

- Uml : # read_uml_() : void
- C++ : protected: virtual void read_uml_()
- Java : protected void read_uml_()

Operation read_cpp_

internal, do NOT use it

Declaration :

- Uml : # read_cpp_() : void
- C++ : protected: virtual void read_cpp_()
- Java : protected void read_cpp_()

Operation read_java_

internal, do NOT use it

Declaration :

- Uml : # read_java_() : void
- C++ : protected: virtual void read_java_()
- Java : protected void read_java_()

Operation read_php_

internal, do NOT use it

Declaration :

- Uml : # read_php_() : void
- C++ : protected: virtual void read_php_()
- Java : protected void read_php_()

Operation read_idl_

internal, do NOT use it

Declaration :

- Uml : # read_idl_() : void
- C++ : protected: virtual void read_idl_()
- Java : protected void read_idl_()

Operation reread_if_needed_

internal, do NOT use it

Declaration :

- Uml : # reread_if_needed_() : void
- C++ : protected: void reread_if_needed_()
- Java : protected void reread_if_needed_()

Extra Class Member friend

Definition :

- C++ :

        friend class UmlBaseArtifact;
        friend class UmlBaseRelation;

All public operations : actuals , addFormal , apply , associatedArtifact , associatedComponents , associatedDiagram , baseType , children , childrenVisible , constraint , cppDecl , cppVisibility , create , defined_ , deleteIt , description , formals , get , getIdentifier , identifier_ , idlDecl , isAbstract , isClassMember , isCppExternal , isIdlCustom , isIdlExternal , isIdlLocal , isJavaExternal , isJavaFinal , isJavaPublic , isMarked , isPhpExternal , isPhpFinal , isToolRunning , isVolatile , isWritable , javaAnnotations , javaDecl , kind , kind , markedItems , moveAfter , name , parent , phpDecl , properties , propertyValue , referencedBy , removeFormal , replaceActual , replaceFormal , set_AssociatedDiagram , set_BaseType , set_childrenVisible , set_Constraint , set_CppDecl , set_CppVisibility , set_Description , set_IdlDecl , set_isAbstract , set_isClassMember , set_isCppExternal , set_isIdlCustom , set_isIdlExternal , set_isIdlLocal , set_isJavaExternal , set_isJavaFinal , set_isJavaPublic , set_isMarked , set_isPhpExternal , set_isPhpFinal , set_isVolatile , set_JavaAnnotations , set_JavaDecl , set_Name , set_Name , set_PhpDecl , set_PropertyValue , set_Stereotype , set_SwitchType , set_Visibility , stereotype , supportFile , switchType , unload , unload , unload , visibility